gillespie <- function(init, times, param, inten, pproc){
    tottime <- times[1]                 
    tinc <- length(times)               
    N <- init                           
    results <- matrix(nrow = tinc, ncol = length(init))
    results[1, ] <- N
    for(i in 2:tinc){
        results[i, ] <- results[i - 1, ]
        while(tottime <= times[i]){
            intentemp <- inten(tottime, N, param)
            if(all(intentemp == 0) || min(intentemp) < 0 || sum(N[2:3]) == 0) {
                results[i, ] <- N
                break
            }
            deltat <- rexp(1, sum(intentemp))
            tottime <- tottime + deltat
            if(tottime > times[i]){
                results[i, ] <- N
                which.pproc <- sample(1:nrow(pproc),
                                  size = 1,
                                  prob = intentemp)
                N <- N + pproc[which.pproc, ]
                break
            }
            which.pproc <- sample(1:nrow(pproc),
                                  size = 1,
                                  prob = intentemp)
            N <- N + pproc[which.pproc, ]    
        }
    }
    cbind(times, results)               
}
